// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

import clientEvent from "./clientEvent";

const {ccclass, property} = cc._decorator;
@ccclass
export default class NewClass extends cc.Component {

    @property(cc.Node)
    target: cc.Node = null;
    rigidBody: cc.RigidBody;
    motor: cc.MotorJoint;
    collider: cc.PhysicsPolygonCollider;

    // LIFE-CYCLE CALLBACKS:

    onLoad () {
        
        this.rigidBody = this.node.getComponent(cc.RigidBody);
        // this.motor.connectedBody
        this.collider =this.node.getComponent(cc.PhysicsPolygonCollider);
        const collisionManager = cc.director.getCollisionManager();
        collisionManager.enabled = true;
    }
    onEnable() {
        clientEvent.on('move', this.move, this);
    }
    move(dir) {
        console.error('move');
        this.node.position = dir;
    }


    onCollsionEnter(other, self) {
        console.error('on collision enter');
    }

    onCollisionStay(other, self) {
        console.error('on collision stay');
    }

    onCollisionExit(other, self) {
        console.error('on collision exit');
    }

    start () {

    }

    update (dt) {
        // this.rigidBody.angularVelocity = 200;
    }

}
